//+------------------------------------------------------------------
//|                                     Klinger volume oscillator.mq4 
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DimGray
#property indicator_color4  Red
#property indicator_width4  2
#property indicator_level1  0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int  LongEma             = 55;
extern int  ShortEma            = 34;
extern int  SignalEma           = 13;
extern bool UseRangeCalculation = true;

double kvo[];
double kvoUp[];
double kvoDn[];
double signal[];

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,kvoUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,kvoDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,kvo);
   SetIndexBuffer(3,signal);
      string add =""; 
         if (UseRangeCalculation) add = "using range";
   IndicatorShortName("Klinger volume "+add+" oscillator ("+LongEma+","+ShortEma+","+SignalEma+") ");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

double work[][6];
#define _price 0
#define _trend 1
#define _dm    2
#define _cm    3
#define _ema1  4
#define _ema2  5

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   double alpha1 = 2.0/(1.0+LongEma);
   double alpha2 = 2.0/(1.0+ShortEma);
   double alpha3 = 2.0/(1.0+SignalEma);
   
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][_price] = (High[i]+Low[i]+Close[i])/3.0;
         work[r][_trend] = work[r-1][_trend];
         
            if (work[r][_price]>work[r-1][_price]) work[r][_trend] =  1;
            if (work[r][_price]<work[r-1][_price]) work[r][_trend] = -1;
         
            //
            //
            //
            //
            //
            
            double volume;
               if (UseRangeCalculation)
               {
                  work[r][_dm] = High[i]-Low[i];
                     if (work[r][_trend]==work[r-1][_trend])
                           work[r][_cm] = work[r-1][_cm]+work[r][_dm];
                     else  work[r][_cm] = work[r-1][_dm]+work[r][_dm];
                  volume = work[r][_trend]*Volume[i] * MathAbs(2.0*work[r][_dm]/work[r][_cm] - 1.0);
               }
               else volume = work[r][_trend]*Volume[i];

            //
            //
            //
            //
            //
            
            work[r][_ema1] = work[r-1][_ema1]+alpha1*(volume-work[r-1][_ema1]);
            work[r][_ema2] = work[r-1][_ema2]+alpha2*(volume-work[r-1][_ema2]);
            kvoUp[i]   = EMPTY_VALUE;    
            kvoDn[i]   = EMPTY_VALUE;    
            kvo[i]     = work[r][_ema2]-work[r][_ema1];
               if (kvo[i]>0) kvoUp[i] = kvo[i];
               if (kvo[i]<0) kvoDn[i] = kvo[i];
               if (SignalEma>1) signal[i] = signal[i+1]+alpha3*(kvo[i]-signal[i+1]);
      }
   
   return(0);
}